<?php 
	session_start();
	require_once 'config.inc.php';
	require_once 'funcs.inc.php';

	$sid=$_SESSION["sid"];
	$uid=$_SESSION["uid"];
	$is_admin=$_SESSION["is_admin"];
	if(!isset($_SESSION["is_admin"]) || !$is_admin) exit();
	$time_format=dlookup("time_format","site","sid=$sid");
	$longtime_format=dlookup("longtime_format","site","sid=$sid");
	require_once('lang.php');

	if(!file_exists("images")) {mkdir("images",0777);chmod("images",0777);}
	if(!file_exists("images/$sid")) {mkdir("images/$sid",0777);chmod("images/$sid",0777);}

	if (isset($_REQUEST["a"]) && $_REQUEST["a"]=="upload"){
		$msg="";
		if($_FILES['f']['size'] ){
			$f=$_FILES['f']['name'];
			$bf=basename($_FILES['f']['name']);
			$fsize=$_FILES['f']['size'] ;
			if(!is_allowed($bf)) 
				$msg="Invalid file type!";
			else if(move_uploaded_file($_FILES['f']['tmp_name'], "images/$sid/$bf")) {
			} else{
				$msg="There was an error uploading file ".  basename( $_FILES['f']['name']).", please try again!";
			}
		}
		?>
		<script defer language="javascript">
			<?php if(strlen($msg)) {?>alert("<?php echo htmlentities($msg,ENT_COMPAT,'utf-8')?>");<?php }?>
			parent.document.getElementById('ajax_loader').style.display='none';
			//parent.sa('mi.php','canvas');
			parent.window.setTimeout('sa(\'mi.php\',\'canvas\');',1);
		</script>
		<?php 
		exit();
	}
	
	if (isset($_REQUEST["a"]) && $_REQUEST["a"]=="del" ){
		$id_array=split(":",rawurldecode($_REQUEST["id"]));
		foreach($id_array as $id){
			if (strlen($id)){
				@unlink("images/$sid/$id");
			}
		}
	}

	if (isset($_REQUEST["a"]) && $_REQUEST["a"]=="ren" ){
		$n=rawurldecode($_REQUEST["n"]);
		$o=rawurldecode($_REQUEST["o"]);
		if (file_exists("images/$sid/$o") && strlen($n) && is_allowed($n)){
			if(false===@rename("images/$sid/$o","images/$sid/$n")) {?><script defer>alert('<?php echo __("Rename failed!")?>');</script><?php }
		}
	}
	
	$a=getdir("images/$sid");
	?>
	<?php echo pathway(__("Images & files"))?>
	<center><div id="wrapper2" style="width:95%;text-align:left;">
	<table style="margin-top:20px;width:99%;" cellspacing=0 class="sort-table"><thead><tr>
		<td width="1%"><input type="checkbox" onclick="var i=1;while(1){if(!elem('cb_'+i)) break; elem('cb_'+i).checked=this.checked;i++;}"/></td>
		<td><?php echo __("Name")?></td><td><?php echo __("Size")?></td><td><?php echo __("Date")?></td><td><?php echo __("Rename")?></td></tr></thead>
	<tbody><?php 
	$i=1;
	foreach($a as $v){
		?>
		<tr><td width="1%"><input type="checkbox" id="cb_<?php echo $i?>" value="<?php echo $v["name"]?>"></td>
			<td><a target="_blank" href="images/<?php echo $sid?>/<?php echo rawurlencode($v['name'])?>"><?php echo $v["name"]?></a></td><td><?php echo formatKb($v["size"])?></td><td><?php echo date($time_format,$v["date"])?></td>
			<td><input style="font-size:6pt;" id="ren<?php echo $i?>"/><button onclick="sa('mi.php?a=ren&o=<?php echo urlencode($v["name"])?>&n='+encodeURIComponent(elem('ren<?php echo $i?>').value),'canvas');"><img alt="Rename" src="ico/bullet_go.gif"/></button></td>
			</tr>
		<?php 
		$i++;
	}
	?></tbody></table>
	<script>
		document.getSelectedIDs=function(){var f=1,r='';while(1){var o=elem('cb_'+f);if(o==null) break;if(o.checked) r+=o.value+':';f++;}return r;}
	</script>
	<button class="button" style="color:red;" onclick="if(getSelectedIDs()!='' && confirm('<?php echo __("Delete selected files?")?>')){ sa('mi.php?a=del&id='+encodeURIComponent(getSelectedIDs()),'canvas');}"><?php echo __("Delete selected")?></button>
	<br>
	<iframe id='target_upload' name='target_upload' src='' style='width:1px;height:1px;border:0'></iframe>
	<form style="margin-top:20px;" target="target_upload" enctype="multipart/form-data" method="POST" id="frmUpload" name="frmUpload" action="mi.php?a=upload">
	<?php echo __("Upload new file:")?><br>
	<input style="width:50%;" type="file" name="f"/><br>
	<input class="button" style="" type="submit" value="<?php echo __("Upload")?>">
	</form>
	</div></center>
	<?php 
function is_allowed($bf){
	$a=array('.php','.pl','.cfm','.asp','.aspx','.htm','.html');
	foreach($a as $v){
		if(substr($bf,-strlen($v))==$v) return 0;
	}
	return 1;
}
?>